<template>
	<view class="postview">
		<view class="postbg" @longpress="longpress">
			<img v-if="!postUrl" class="post" src="https://ikea-mrm.woaap.com/images/postbg.jpg" @load="isload" />
			<img v-if="!postUrl" class="avatar" :src="userInfo.avatarUrl" />
			<text v-if="!postUrl" class="nickName">{{ userInfo.nickName }}</text>
			<text v-if="!postUrl" class="chooseValue">玩在一起，{{ chooseValue }}</text>
			<img v-if="!postUrl" class="qrcode" :src="qrcode" />
			<img v-if="postUrl" class="post pos" :src="postUrl" />
			<img class="toast" :class="{ blink: isfadeout }" src="https://ikea-mrm.woaap.com/images/toast2.png" />
			<painter class="painter" :dirty="true" v-if="palette != null" :palette="palette" @imgOK="onImgOK" @imgErr="onImgErr"></painter>
		</view>
	</view>
</template>

<script>
export default {
	data() {
		return {
			palette: {},
			canvasScale: 3,
			userInfo: getApp().globalData.userInfo,
			postUrl: '',
			isfadeout: false,
			chooseValue: '',
			qrcode: 'https://ikea-mrm.woaap.com/images/noqrcode.png' //'https://ikea-mrm.woaap.com/images/haveqrcode.png'
		};
	},
	onShareAppMessage: function(res) {
		return {
			title: '宜家PLAY护照 限时申领中',
			path: 'pages/index/index',
			imageUrl: 'https://ikea-mrm.woaap.com/images/share/share_passport.jpg'
		};
	},
	onShow() {
		getApp().td_app_sdk.event({
			id: 'fenxianghaibaoye',
			label: 'pv',
			params: {}
		});
	},
	mounted() {
		this.chooseValue = wx.getStorageSync('chooseValue');
		console.log(this.userInfo);
		uni.showLoading({
			title: '为您生成护照中'
		});
	},
	methods: {
		isload() {
			this.palette.width = `${750 * this.canvasScale}rpx`;
			this.palette.height = `${1624 * this.canvasScale}rpx`;
			// this.palette.background = "https://ikea-mrm.woaap.com/images/notgamepost.jpg"
			this.palette.views = [];
			this.palette.views.push(
				{
					type: 'image',
					url: 'https://ikea-mrm.woaap.com/images/postbg.jpg',
					css: {
						top: `0rpx`,
						left: `0rpx`,
						width: `${750 * this.canvasScale}rpx`,
						height: `${1624 * this.canvasScale}rpx`
					}
				},
				{
					type: 'image',
					url: this.qrcode,
					css: {
						top: `${1155 * this.canvasScale}rpx`,
						left: `${50 * this.canvasScale}rpx`,
						width: `${658 * this.canvasScale}rpx`,
						height: `${132 * this.canvasScale}rpx`
					}
				},
				{
					type: 'image',
					url: this.userInfo.avatarUrl,
					css: {
						top: `${450 * this.canvasScale}rpx`,
						left: `${270 * this.canvasScale}rpx`,
						width: `${200 * this.canvasScale}rpx`,
						height: `${200 * this.canvasScale}rpx`,
						borderRadius: `${100 * this.canvasScale}rpx`,
						borderWidth: `${10 * this.canvasScale}rpx`,
						borderColor: '#fed931'
					}
				},
				{
					type: 'text',
					text: this.userInfo.nickName,
					css: {
						top: `${720 * this.canvasScale}rpx`,
						left: `${50 * this.canvasScale}rpx`,
						fontSize: `${36 * this.canvasScale}rpx`,
						fontWeight: 'bold'
					}
				},
				{
					type: 'text',
					text: '玩在一起，' + this.chooseValue,
					css: {
						top: `${1010 * this.canvasScale}rpx`,
						left: `${50 * this.canvasScale}rpx`,
						fontSize: `${36 * this.canvasScale}rpx`,
						fontWeight: 'bold'
					}
				}
			);

			this.$forceUpdate();
		},
		onImgErr() {
			uni.showToast({
				title: '错误错误'
			});
		},
		onImgOK(e) {
			console.log(e.detail.path);
			this.$forceUpdate();
			this.postUrl = e.detail.path;
			uni.hideLoading();
			this.isfadeout = true;
			// setTimeout(()=>{
			// 	this.isfadeout = true
			// },3000)
		},
		//长按保存
		longpress() {
			getApp().td_app_sdk.event({
				id: '长按保存',
				label: 'click'
			});
			uni.showLoading({
				title: '请稍后',
				mask: true
			});
			uni.getSetting({
				success: res => {
					console.log(res);
					if (!res.authSetting['scope.writePhotosAlbum']) {
						uni.authorize({
							scope: 'scope.writePhotosAlbum',
							success: () => {
								//1.1 允许授权
								this.saveImg(this.postUrl);
							},
							fail() {
								//1.2 拒绝授权
								// 授权失败
								uni.showModal({
									title: '警告',
									content: '您点击了拒绝授权,将无法正常保存图片,点击确定重新获取授权。',
									success: function(res) {
										if (res.confirm) {
											uni.openSetting({
												success: res => {
													uni.showToast({
														icon: 'success',
														title: '授权成功',
														duration: 2000
													});
												}
											});
										}
									}
								});
							}
						});
					} else {
						this.saveImg(this.postUrl);
					}
				},
				complete() {
					uni.hideLoading();
				}
			});
		},
		saveImg(url) {
			uni.showLoading({
				title: '图片保存中',
				mask: true
			});
			uni.saveImageToPhotosAlbum({
				filePath: url,
				success: () => {
					uni.showToast({
						icon: 'success',
						title: '保存成功',
						duration: 2000
					});
				},
				fail() {
					console.log('保存失败');
				},
				complete() {
					uni.hideLoading();
				}
			});
		},
		_image(url, width, height, left, top, rotate) {
			//url图片地址 width 宽度 height高度  left左距离  top右距离 rotate旋转角度
			return {
				type: 'image',
				url: url,
				css: {
					top: top,
					left: left,
					width: width,
					height: height,
					rotate: rotate
				}
			};
		}
	}
};
</script>

<style lang="less">
.postview {
	width: 100vw;
	height: 100vh;
	overflow: hidden;
	position: relative;
}
.postbg {
	width: 750upx;
	height: 1624upx;
	position: absolute;
	top: 50%;
	transform: translate(0, -49%);
	.toast {
		width: 283rpx;
		height: 63rpx;
		position: absolute;
		top: 50%;
		left: 50%;
		transform: translate(-50%, -50%);
		z-index: 999;
		opacity: 0;
	}
	.pos {
		z-index: 99;
	}
	.post {
		width: 100%;
		height: 100%;
		position: absolute;
		left: 0;
		top: 0;
	}
	.avatar {
		position: absolute;
		left: 270upx;
		top: 450upx;
		width: 200upx;
		height: 200upx;
		border-radius: 50%;
		border: 10upx solid #fed931;
	}
	.nickName {
		position: absolute;
		left: 50upx;
		top: 720upx;
		font-family: '黑体';
		font-weight: 900;
		font-size: 36upx;
	}
	.chooseValue {
		position: absolute;
		left: 50upx;
		top: 1010upx;
		font-family: '黑体';
		font-weight: 900;
		font-size: 36upx;
	}
	.qrcode {
		position: absolute;
		width: 658rpx;
		height: 132rpx;
		left: 50rpx;
		top: 1155rpx;
	}
}
.painter {
	position: absolute !important;
	top: 200vh;
}
</style>
